/*
 * Copyright (C) 2000, David Decotigny
 * http://kos.enix.org                 
 * 
 * Loader configuration
 * 
 * @(#) $Id: config.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#ifndef __KOS_LOADER_CONFIG_H__
#define __KOS_LOADER_CONFIG_H__

#define __IN_LOADER__ 1


/*
 * Keep the kernel symbols (functions only) for use with lookup_symbol
 * from inside the kernel
 */
#define KEEP_KSYMS


/*
 * If you want the debugging messages to be printed on the term, when
 * you use bochs (compiled with --enable-e9-hack)
 */
#undef DEBUG_ON_BOCHS

/*
 * If you want the debug messages to be sent directly to screen
 */
#undef DEBUG_ON_CONSOLE

/*
 * If you want the debug messages to be sent to the serial line (set
 * in 8N1)
 */
#undef DEBUG_ON_SERIAL
#define DEBUG_SERIAL_PORT  0
#define DEBUG_SERIAL_SPEED 115200

/*
 * For those who don't want to see the messages when a function is
 * being abnormally aborted (ASSERT_RETURN() or ASSERT_RETURN_VAL())
 */
#undef __SILENT_ASSERT_RETURN__

/*
 * For those who want to fine-tune the link-stage, enable
 * this. WARNING: rdtsc is not implemented in bochs, SO DON'T DEFINE
 * THIS IF YOU'RE USING BOCHS !
 */
#undef CYCLE_COUNT

/* 
 * Compute module checksum
 */
#undef COMPUTE_CHECKSUM

#endif /* __KOS_LOADER_CONFIG_H__ */



