/*
 * Copyright (C) 2000, Christophe Avoinne
 * http://kos.enix.org
 *
 * Bochs console access
 *
 * @(#) $Id: bochs.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */


/* These functions are used in order to write to the console having
   started BOCHS using a great little hack written by Emmanuel Marty
   (core@suntech.fr).

   Note: You need to have bochs compiled with the
   --enable-port-e9-hack feature enabled
*/

#include <libcrt/stdio.h>
#include <debug/bochs.h>

#define inb(port)						\
({								\
  unsigned char _v;						\
  __asm__ volatile (						\
	"inb %w1,%0"						\
	:"=a" (_v)						\
	:"Nd" (port)						\
	);							\
  _v;								\
})


#define outb(value, port)					\
  __asm__ volatile (	       					\
	"outb %b0,%w1"						\
	::"a" (value),"Nd" (port)				\
	)							\


void bochs_putchar( int c ) 
{
  outb(c, 0xE9);
}

void bochs_printl(char *format, ...) 
{
  char **arg = (char **) &format;
  int c;
  char buf[20];
  
  arg++;
  

  while ((c = *format++) != 0)
    {
      if (c != '%')
	bochs_putchar (c);
      else
	{
	  char *p;
	  
	  c = *format++;
	  switch (c)
	    {
	    case 'd':
	    case 'u':
	    case 'x':
	      itoa (buf, c, *((int *) arg++));
	      p = buf;
	      goto string;
	      break;

	    case 's':
	      p = *arg++;
	      if (! p)
		p = "(null)";

	    string:
	      while (*p)
		bochs_putchar (*p++);
	      break;

	    default:
	      bochs_putchar (*((int *) arg++));
	      break;
	    }
	}
    }
}
