
#include "_elf32.h"

char*  elf32_get_section_name(struct elf_mod_info_s* emod,
			      Elf32_Shdr *section)
{
  Elf32_Shdr *h_strtable = emod->section + emod->header->e_shstrndx;
  char *name;

  if (emod->header->e_shstrndx == SHN_UNDEF)
    return "<unknown>";

  /* elf32_check already made sure e_shstrndx was correct */
  name = (char*)(((vaddr_t)emod->header)
		 + h_strtable->sh_offset
		 + section->sh_name);
  if (*name == '\0')
    return "<none>";
  
  return name;
}


#define ELF_OP(name,funct) { name, funct }

static struct ld_bfd_operation_struct elf32_passes[] = {
  ELF_OP("init", elf32_init),
  ELF_OP("alloc", elf32_alloc),
  ELF_OP("build", elf32_build),
  ELF_OP("reloc local", elf32_relocate_local),
  ELF_OP("update tables", elf32_update_tables),
  ELF_OP("reloc import", elf32_relocate_import)
};


struct ld_bfd_operations_struct elf32_ops = {
  "ELF32 binary",
  elf32_check_magic,
  sizeof(elf32_passes) / sizeof(struct ld_bfd_operation_struct),
  elf32_passes
};
