/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Simple printl function for the KOS kernel loader
 *
 * @(#) $Id: printl.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#include "stdarg.h"
#include "stdio.h"

void printl (const char *format, ...)
{
  va_list ap;
  int c;
  char buf[20];

  va_start(ap, format);
  
  while ((c = *format++) != 0)
    {
      if (c != '%')
	putchar (c);
      else
	{
	  char *p;
	  
	  c = *format++;
	  switch (c)
	    {
	    case 'd':
	    case 'u':
	    case 'x':
	      itoa (buf, c, va_arg(ap, int));
	      p = buf;
	      goto string;
	      break;

	    case 's':
	      p = va_arg(ap, char*);
	      if (! p)
		p = "(null)";

	    string:
	      while (*p)
		putchar (*p++);
	      break;

	    default:
	      putchar (va_arg(ap, int));
	      break;
	    }
	}
    }
  va_end(ap);
}
