/*
 * Copyright (C) 2000
 * http://kos.enix.org                 
 * 
 * Header for standard string functions.
 * 
 * @(#) $Id: string.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */
#ifndef __STRING_H__
#define __STRING_H__


void         *memcpy( void *dst0, const void *src0, register unsigned int size ) ;
void         *memset( void *dst0, register int c0, register unsigned int length ) ;

unsigned int strlen( register const char *str ) ;

char         *strcpy( register char *dst, register const char *src ) ;
char         *strncpy( register char *dst, register const char *src, register int len ) ;

int          strcmp( register const char *s1, register const char *s2 );
/* 
 * Semantic DOES NOT follow the official one of strncpy(3C) !
 * Actually, strncpy(3C) says " The result will not  be  null-terminated
 * if  the length of 'from' is n or more.".
 * Here, 'to' is ALWAYS null-terminated. And its total len will ALWAYS  
 * be <= len, with null-terminating-char included.
 */
int          strncmp( register const char *s1, register const char *s2, register int len );

#endif /* __STRING_H__ */
