/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Standard string functions
 *
 * @(#) $Id: strncpy.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#include <types.h>
#include "string.h"

/*
 * Semantic DOES NOT follow the official one of strncpy(3C) !
 * Actually, strncpy(3C) says " The result will not  be  null-terminated
 * if  the length of 'from' is n or more.".
 * Here, 'to' is ALWAYS null-terminated. And its total len will ALWAYS
 * be <= len, with null-terminating-char included.
 */
char *strncpy(register char *dst, register const char *src, register int len)
{
        char *tmp = dst;

        while ((len-- > 0) && (*src))
          *(dst++) = *(src++);

        *(dst) = '\0';
        
        return tmp;
}
