/*
 * Copyright (C) 2000, David Decotigny
 * http://kos.enix.org                 
 * 
 * Macros header
 * 
 * @(#) $Id: macros.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */


#ifndef __KOS_LD_MACROS_H__
#define __KOS_LD_MACROS_H__

#include <debug/debug.h>

#define UNUSED(arg) (arg) = (arg)

#ifndef NULL
#define NULL ((void*)0)
#endif

#ifndef RETURN_OK
#define RETURN_OK    0
#endif

#ifndef RETURN_FAIL
#define RETURN_FAIL -1
#endif

/* Align on a boundary (MUST be a power of 2), so that return value <= val */
#define ALIGN_INF(val,boundary) \
  ((unsigned)(((int)val) & (~((boundary)-1))))

/* Align on a boundary (MUST be a power of 2), so that return value >= val */
#define ALIGN_SUP(val,boundary) \
  ((unsigned)((((int)(val)-1) & (~((boundary)-1))) + (boundary)))


#define WARNING(fmt,args...) ({ \
  DEBUG_PRINT_VERBOSE("Warning: "); \
  DEBUG_PRINT(fmt, ## args) ; \
})

#define RETURN_IF_FAIL(expr) ({ \
  int __res=(int)(expr); \
  if (! __res) \
    return; \
})

#define RETURN_VAL_IF_FAIL(expr,val) ({ \
  int __res=(int)(expr); \
  if (! __res) \
    return val; \
})

#define PAUSE(str)
//#define PAUSE(str) ({ int j; printl("Pause(%s)...", str); for (j = 0 ; j <= 10000UL ; j++) ; printl("End pause\n"); })

#endif /* __KOS_LD_MACROS_H__ */
