/*
 * Copyright (C) 2000, Julien Munier, Thomas Petazzoni
 * http://kos.enix.org                 
 * 
 * Memory Initialization Header
 * 
 * @(#) $Id: _mm.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */
#ifndef __KOS_LD_PRIV_MM_H__
#define __KOS_LD_PRIV_MM_H__

#include "mm.h"

#define PAGE_SIZE 4096

/* Mirroring: PD mapped at PD[CURRENT_PT_AREA_INDEX] */
#define CURRENT_PT_AREA_INDEX 509 /* MUST be consistent with
                                     modules/arch/mm/mm.h */
#define CURRENT_PT_AREA_START \
  (1UL*CURRENT_PT_AREA_INDEX*1024*PAGE_SIZE)
#define CURRENT_PD_VADDR \
  (CURRENT_PT_AREA_START + CURRENT_PT_AREA_INDEX*PAGE_SIZE)

/* For pmm */
struct free
  {
    unsigned int
      size,
      skip;
  };

extern struct free
  *pmm_head,
  *pmm_tail,
  *pmm_base;

/* For vmm */
#define flush_tlb() \
  do { \
	unsigned long tmpreg; \
       __asm__ __volatile__("movl %%cr3,%0\n\tmovl %0,%%cr3" :"=r" (tmpreg) : :"memory"); \
  } while (0)


#define va_to_pde(va) ((va) >> 22)
#define va_to_pte(va) (((va) >> 12) & 0x3ff)

int  vmm_init(size_t im_size);
void pmm_init(multiboot_info_t *mbi, unsigned long loader_upper_mem);

void map_virtual_to_physical(addr_t virt, addr_t phys, int flags);

void pmm_mark_free(void *block, unsigned int size);


void  *pmm_page_alloc(unsigned int size);
void  *pmm_realloc(void *block, unsigned int size);
void   pmm_free(void *block);
void   pmm_dump(void);

#endif
