/*
 * Copyright (C) 2000, Christophe Avoinne
 * http://kos.enix.org
 *
 * Dumpmem function for the heap memory manager
 *
 * @(#) $Id: pmm_dump.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#include <debug/debug.h>
#include <libcrt/stdio.h>

#include "_mm.h"

void pmm_dump (void)
{
  int i;
  int j;
  struct free *p = pmm_base; 


  if (p < pmm_head)
    {
      i = pmm_head-p;
      DEBUG_PRINT("\n ");
      DEBUG_PRINT("%x", (unsigned)p);
      DEBUG_PRINT("-");
      DEBUG_PRINT("%x", (unsigned)p+i);
      DEBUG_PRINT(" : used");
      p+= i;
    }
  
  while (p < pmm_tail)
    {
      i = p->size;
      j = p->skip;
      DEBUG_PRINT("\n ");
      DEBUG_PRINT("%x", (unsigned)p);
      DEBUG_PRINT("-");
      DEBUG_PRINT("%x", (unsigned)p+i);
      DEBUG_PRINT(" : free +");
      DEBUG_PRINT("%x", j*8);
      p+= i;
      j-= i;
      if (j)
        {
	  DEBUG_PRINT("\n ");
          DEBUG_PRINT("%x", (unsigned)p);
          DEBUG_PRINT("-");
          DEBUG_PRINT("%x", (unsigned)p+j);
          DEBUG_PRINT(" : used");
        }
      p+= j;
    }

  DEBUG_PRINT("\n base : ");
  DEBUG_PRINT("%x", (unsigned)pmm_base);
  DEBUG_PRINT("\n head : ");
  DEBUG_PRINT("%x", (unsigned)pmm_head);
  DEBUG_PRINT("\n tail : ");
  DEBUG_PRINT("%x", (unsigned)pmm_tail);
}









