
#ifndef __KOS_LD_UTILS_H__
#define __KOS_LD_UTILS_H__

#include <stdio.h>

#define DFLT_DOT "moddep.dot"

/* ************************************************************
 * POSIX wrappers to the KOS loader library functions
 */
#define ALIGN_SUP(val,boundary) \
  ((unsigned)((((int)(val)-1) & (~((boundary)-1))) + (boundary)))

#define DBG(fmt,args...) ({ \
  if (debug) \
    fprintf(stderr, fmt, ##args); \
})

extern int debug;
extern int view_console_output;
extern int view_bochs_output;
extern int view_serial_output;

int bochs_printl(const char *format, ...);
int serial_printl(const char *format, ...);
int printl (const char *format, ...);
void halt(void);
void *vmm_page_alloc(size_t size, addr_t *allocated_phys_addr);
void *pmm_malloc(unsigned int size);

/* deps.c */
void deps_imp(FILE* f,
	      ld_module_t* ldmod,
	      int detail_by_symbol);
void deps_exp(FILE* f,
	      struct ld_module_struct* owned_by,
	      int detail_by_symbol);
void deps_all(FILE* f,
	      int detail_by_symbol);

/* initlevels.c */
int print_init_order(unsigned int base_level, unsigned int nb_levels);

/* map.c */
int gen_bochs_symfile(char* fname);

#endif
