/*
 * Copyright (C) 2000, David Decotigny
 * http://kos.enix.org                 
 * 
 * Modules configuration
 * 
 * @(#) $Id: config.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#ifndef __KOS_MODULES_CONFIG_H__
#define __KOS_MODULES_CONFIG_H__

#define __IN_MODULE__ 1

/*
 * Number of activable CPUs in system
 */
#define NB_CPU 1

/*
 * These defines allow to enable or disable support for each debugging
 * method. If one of these fails, you can disable it here.
 */

#define DEBUG_BOCHS_SUPPORT
//#define DEBUG_SERIAL_SUPPORT
//#define DEBUG_SERIAL_PORT  0
//#define DEBUG_SERIAL_SPEED 115200

/*
 * For those who don't want to see the messages when a function is
 * being abnormally aborted (ASSERT_RETURN() or ASSERT_RETURN_VAL()) */
#undef __SILENT_ASSERT_RETURN__

/*
 * For those who want to fine-tune the link-stage, enable
 * this. WARNING: rdtsc is not implemented in bochs, SO DON'T DEFINE
 * THIS IF YOU'RE USING BOCHS !
 */
#undef CYCLE_COUNT


/*
 * For those who want to have some debugging information concerning
 * deadlock or misuse of spinlocks, event on UP.
 */
//If you define this, be careful with the gpfme_t which will change !
#define __DEADLOCK_CHECK__ 0x56

#endif /* __KOS_MODULES_CONFIG_H__ */






