/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Debug functions on bochs ports (e8 + e9)
 *
 * @(#) $Id: bochs.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#include "bochs.h"

#include <loader/mod.h>
#include <lib/stdio.h>
#include <kos/asm.h>

void bochs_putchar(int c) 
{
  outb(c, 0xE9);
}

static char bochs_printk_buf[1024];

inline int bochs_prints(const char *str)
{
  const char *c;
  
  for (c = str; *c != '\0'; c++)
    bochs_putchar(*c);

  return (int) (c-str);
}

int bochs_printk(const char *format, ...) 
{
  va_list args;
  int len;

  va_start(args, format);
  len=vsprintf(bochs_printk_buf,format,args);

  return bochs_prints(bochs_printk_buf);
}



EXPORT_FUNCTION(bochs_putchar);
EXPORT_FUNCTION(bochs_printk);
EXPORT_FUNCTION(bochs_prints);


