#ifndef ___ELF_H__
#define ___ELF_H__

#include <elf/elf.h>

/* elf32.h */

typedef unsigned long Elf32_Addr;
typedef unsigned long Elf32_Word;
typedef unsigned short Elf32_Half;
typedef unsigned long Elf32_Off;
typedef signed long Elf32_Sword;

/* Elf identification */

#define EI_NIDENT       16
#define EI_MAG0		0
#define EI_MAG1 	1
#define EI_MAG2		2
#define EI_MAG3 	3
#define EI_CLASS	4  
#define EI_DATA		5  
#define EI_VERSION	6  
#define EI_PAD		7  

typedef struct {
  unsigned char       e_ident[EI_NIDENT];
  Elf32_Half          e_type;
  Elf32_Half          e_machine;
  Elf32_Word          e_version;
  Elf32_Addr          e_entry;
  Elf32_Off           e_phoff;
  Elf32_Off           e_shoff;
  Elf32_Word          e_flags;
  Elf32_Half          e_ehsize;
  Elf32_Half          e_phentsize;
  Elf32_Half          e_phnum;
  Elf32_Half          e_shentsize;
  Elf32_Half          e_shnum;
  Elf32_Half          e_shstrndx;
} Elf32_Ehdr;


#endif
