#include <babel/tower/tower.h>
#include <fs/fat/_fat.h>
#include <kos/types.h>
#include <kos/assert.h>
#include <kos/macros.h>

static int fat_destructor(struct translator *trans, void *rc);
static struct translator *fat_get_trans(struct translator *trans,
					char *relpath,
					int relpath_len/*-1:auto*/);


struct fat_methods_table fat_methods_table = {
  .parent= {
    .check_capability = fat_check_capability,
    .getsize          = fat_getsize
  }
};

struct fs_kernel_methods_table fat_kernel_methods_table = {
  .parent= {
    .read=        fat_read,
    .write=       NULL,
    .init_sr=     fat_init_sr,
    .init_res=    NULL,
    .cleanup_sr=  NULL,
    .cleanup_res= NULL },
  .get_trans=   fat_get_trans
};

struct interface fat_interface = {
  .name=        "fat", 
  .family=      "fs",
  .description= "Fat partitions managament",
  .authors=     "Thomas Petazzoni, Julien Munier",
  .depends=     NULL,

  .version= { 0, 0, 1 },       

  .prev=       NULL, 
  .next=       NULL,        
  .trans_list= NULL,              

  .max_trans_instance= 8,                 
  .trans_size=         sizeof(struct fat_translator),
  .res_size=           0,
  .sr_size=            sizeof(struct fat_shadow_resource),
  .trans_cnt=          0,
  .trans_greatest_id=  0,

  .constructor=  fat_constructor,
  .destructor=   fat_destructor,

  .kernel_methods= (struct kernel_methods_table *)&fat_kernel_methods_table,
  
  .methods_table= (struct interface_mt *)&fat_methods_table,
  .shared_data=   NULL
};

static int fat_destructor(struct translator *trans, void *rc)
{
  UNUSED(trans);
  UNUSED(rc);
  return 0;
}

static struct translator *fat_get_trans(struct translator *trans,
					char *relpath,
					int relpath_len/*-1:auto*/)
{
  UNUSED(relpath);
  UNUSED(relpath_len);
  return trans;
}









