#ifndef __FILESYSTEM_H__
#define __FILESYSTEM_H__

#include <babel/interface.h>
#include <babel/translator.h>

#define FS_REMOUNT 0x1

typedef struct fs_kernel_methods_table {
  struct kernel_methods_table parent;
  struct translator *(*get_trans)(struct translator *,
				  char *sr_relpath,
				  int relpath_len /*-1:auto*/);
} fs_kernel_methods_table_t;

typedef struct fs_methods_table {
  int (*check_capability)(struct shadow_resource *);
  int (*getsize)(struct resource *);
} fs_methods_table_t;

typedef struct fs_constructor_parameters {
  struct shadow_resource *part;
  int flags;
} fs_constructor_parameters_t;

#endif /* __FILESYSTEM_H__ */
