#include <loader/mod.h>
#include <i8042/i8042.h>
#include <lib/stdio.h>
#include <idt/irq.h>
#include <kos/macros.h>

i8042_vec_t _i8042_vec = { .klavier= NULL,
			   .maus=    NULL };

int _i8042_register_klavier_handler(int(*klavier)(void))
{
  if (klavier == NULL)
    return -1;
  
  _i8042_vec.klavier = klavier;

  return 0;
}

int _i8042_register_maus_handler(int(*maus)(void))
{
  if (maus == NULL)
    return -1;

  _i8042_vec.maus = maus;

  return 0;
}


__init_text static int init_module_level0(kernel_parameter_t *kp)
{
  UNUSED(kp);

  printk("(Init module i8042...");
  register_irq_handler(I8042_IRQ,
		       _i8042);
  
  printk("Ok)\n");
  return 0;
}

EXPORT_FUNCTION(_i8042_register_klavier_handler);
EXPORT_FUNCTION(_i8042_register_maus_handler);

DECLARE_INIT_SYMBOL(init_module_level0, INIT_LEVEL4);
