#ifndef __i8042_H__
#define __i8042_H__

#include <kos/types.h>
#include <arch/task/task.h>

#define I8042_IRQ    IRQ_KEYBOARD
#define DATA_PORT    0x60
#define COMMAND_PORT 0x64

typedef uint k_code_t;

typedef struct _i8042_vec_s {
  int (*klavier)(void);
  int (*maus)(void);
} i8042_vec_t;


int _i8042_register_klavier_handler(int (*klavier)(void));
int _i8042_register_maus_handler(int (*maus)(void));

void _i8042(int number, cpu_state_t *cpu_state);


#endif /* __i8042_H__ */
