#ifndef __BABEL_BLOCK_H__
#define __BABEL_BLOCK_H__

#include <babel/interface.h>
#include <babel/translator.h>
#include <babel/resource.h>

typedef struct block_methods_s
{
  int (*open)(char *);
  int (*read)(int resource, char *buffer);
  int (*write)(int resource, char *buffer);
  int (*close)(int resource);
} block_methods_table_t;

typedef struct block_shared_data_s
{
  int this_var_is_shared;
} block_shared_data_t;

typedef struct block_translator_s
{
  struct translator_s parent;
  int this_var_is_private;
} block_translator_s;

typedef struct block_resource_s
{
  struct resource_s parent;
  int this_var_is_resource;
} block_resource_s;








#endif /* __BABEL_BLOCK_H__ */
