#ifndef __IDE_H__
#define __IDE_H__

#include <babel/translator.h>
#include <kos/types.h>

#define NB_CONTROLLERS       2
#define PRIMARY_CONTROLLER   0
#define SECONDARY_CONTROLLER 1
#define MASTER 0
#define SLAVE  1
#define READ   0
#define WRITE  1

typedef struct controller
{
  k_ui16_t ioaddr;
  k_ui16_t irq;

  enum { ATA_NOT_PRESENT, ATA_IDLE, ATA_WAIT_INTR } state;
  int ctrl;

  /* Devices types */
#define ATA_ATA_MASTER                  0x01
#define ATA_ATA_SLAVE                   0x02
#define ATA_ATAPI_MASTER                0x04
#define ATA_ATAPI_SLAVE                 0x08
  int devices;

} controller_t;

typedef struct ide_translator
{
  struct translator parent;
  
  k_ui16_t logical_cylinder_nb;
  k_ui16_t logical_head_nb;
  k_ui16_t logical_sector_per_track;
  k_ui32_t lba_capacity;
  k_ui32_t blk_size;

  char serial_number[21];
  char firmware_revision[9];
  char model_number[41];

  controller_t *ctrl;
#define HARDDISK_LBA_CAPABLE 0x1
  int flags;

  int size;
  int device;
} ide_translator_t; 


/* used only by constructor
 */
struct ide_dev {
  struct controller *controller;
  int device;
};


#endif /* __IDE_H__ */
