/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Include file for DSR (deferred service routines) management
 *
 * @(#) $Id: _dsr.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#ifndef ___DSR_H__
#define ___DSR_H__

#include <kos/macros.h>
#include <idt/dsr.h>

typedef struct dsr 
{
  dsr_handler_t *handler; 
  void *data;
  enum { UNREGISTERED_DSR, INACTIVE_DSR, PENDING_DSR, EXECUTING_DSR } state;
} dsr_t;


typedef struct dsr_queue 
{
  /* Bit = 1 <=> at least one DSR registered in the corresponding queue */
  unsigned char bitmap[ALIGN_SUP(DSR_LEVELS, CHAR_BITS) / CHAR_BITS];

  dsr_t level[DSR_LEVELS];
  
} dsr_queue_t;


/* One queue per CPU */
extern dsr_queue_t dsr_queue[NB_CPU];

int init_dsr(void);

#endif /* ___DSR_H__ */
