#ifndef ___DST_H__
#define ___DST_H__

#include <idt/dst.h>
#include <task/task.h>
#include <kos/spinlock.h>
#include <kitc/kmsg.h>

/* Further defined */
struct dst;

typedef struct dst_job
{
  dst_handler_t *handler;
  void *data;

  struct dst *owner;
  enum { INACTIVE_DST, PENDING_DST, EXECUTING_DST } state;
} dst_job_t;

typedef struct dst 
{
  kmsg_port_t *msg_port;
  thread_t *thread;
  spinlock_t lock;
  int dst_level;
} dst_t;

extern dst_t _dst[DST_LEVELS];

void init_dst(void);

#endif /* ___DST_H__ */
