#ifndef ___IDT_H__
#define ___IDT_H__

#define EXCEPTION_BASE 0
#define IRQ_BASE       32
#define SYSCALL_BASE   48

#define IDT_ENTRIES    49

#include <idt/_irq.h>
#include <idt/_exception.h>
#include <idt/_syscall.h>

/* ASM Source does not have access to this part of the file */
#ifndef ASM_SOURCE

#include <idt/_dsr.h>
#include <idt/_i8259.h>
#include <idt/_dst.h>

#include <arch/task/task.h>
#include <kos/types.h>

typedef struct 
{
  k_ui16_t offset_low;
  k_ui16_t seg_sel;
  k_ui8_t flags;
  k_ui8_t type:3;
  k_ui8_t gate_size:1;
  k_ui8_t zero:1;
  k_ui8_t dpl:2;
  k_ui8_t present:1;
  k_ui16_t offset_high;
} idt_entry_t __attribute__((packed));

/* ASSUMES cli ! */
void _init_idt(void);

extern idt_entry_t _idt[IDT_ENTRIES];

#endif /* ASM_SOURCE */

#endif /* ___IDT_H__ */
