/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Syscall Management functions.
 * Part of the idt.o module
 *
 * @(#) $Id: _syscall.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#include <kos/macros.h>
#include <kos/assert.h>
#include <kos/asm.h>
#include <idt/_syscall.h>
#include <idt/_idt.h>

static void deflt_kos_syscall(int number, cpu_state_t *cpu_state);

syscall_handler_t syscall_handler[NUM_SYSCALL] = { deflt_kos_syscall };

syscall_handler_t register_syscall_handler(short num_ex, 
					   syscall_handler_t new_ex)
{
  syscall_handler_t old_ex;

  if ((num_ex < 0) || (num_ex >= NUM_SYSCALL))
    return NULL;

  old_ex = syscall_handler[num_ex];
  syscall_handler[num_ex] = new_ex;

  return old_ex;
}


addr_t get_syscall_handler_address(int num_ex)
{
  addr_t ex_addr;
  
  CONCEPTION_ASSERT((num_ex >= 0) && (num_ex < NUM_SYSCALL));

  ex_addr = _idt[num_ex+SYSCALL_BASE].offset_low;
  ex_addr |= (_idt[num_ex+SYSCALL_BASE].offset_high << 16);
  
  return ex_addr;
}


static void deflt_kos_syscall(int number, cpu_state_t *cpu_state)
{
  UNUSED(number);
  UNUSED(cpu_state);

  __dbg_printk("Welcome to KOS Syscall...\n");
}


