/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Include file for DSR (deferred service routines) management
 *
 * @(#) $Id: dsr.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#ifndef __DSR_H__
#define __DSR_H__

#include <kos/macros.h>

#define DSR_LEVELS 42
#define DSR_LAST   (DSR_LEVELS-1)
#define DSR_FIRST  0


typedef void ((dsr_handler_t)(int dsr_q, void *data));

/*
 * 0 when Ok; -1 on error (DSR level already registered)
 * Register the DSR for the current cpu
 */
int register_dsr(int dsr_level,
		 dsr_handler_t *handler,
		 void *data);

typedef enum { E_DSR_OK=0, E_DSR_TRY_AGAIN=1, E_DSR_ERROR=-1 } e_dsr_t;
e_dsr_t unregister_dsr(int dsr_level);

int mark_dsr(int dsr_level);


/* Assumes interrupts are disabled. Returns with interrupts disabled */
void spawn_dsr(void);

#endif /* __DSR_H__ */
