/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Include file for exception management
 *
 * @(#) $Id: exception.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#define NUM_EXCEPTION 32

// List of interruptions                             Error code ?
#define DIVIDE_ERROR                       0         // No error code
#define DEBUG                              1         // No error code
#define NMI_INTERRUPT                      2         // No error code
#define BREAKPOINT                         3         // No error code
#define OVERFLOW                           4         // No error code
#define BOUND_RANGE_EXCEDEED               5         // No error code
#define INVALID_OPCODE                     6         // No error code
#define DEVICE_NOT_AVAILABLE               7         // No error code
#define DOUBLE_FAULT                       8         // Yes (Zero)
#define COPROCESSOR_SEGMENT_OVERRUN        9         // No error code
#define INVALID_TSS                       10         // Yes
#define SEGMENT_NOT_PRESENT               11         // Yes
#define STACK_SEGMENT_FAULT               12         // Yes
#define GENERAL_PROTECTION                13         // Yes
#define PAGE_FAULT                        14         // Yes
#define INTEL_RESERVED_1                  15         // No
#define FLOATING_POINT_ERROR              16         // No
#define ALIGNEMENT_CHECK                  17         // Yes (Zero)
#define MACHINE_CHECK                     18         // No
#define INTEL_RESERVED_2                  19         // No
#define INTEL_RESERVED_3                  20         // No
#define INTEL_RESERVED_4                  21         // No
#define INTEL_RESERVED_5                  22         // No
#define INTEL_RESERVED_6                  23         // No
#define INTEL_RESERVED_7                  24         // No
#define INTEL_RESERVED_8                  25         // No
#define INTEL_RESERVED_9                  26         // No
#define INTEL_RESERVED_10                 27         // No
#define INTEL_RESERVED_11                 28         // No
#define INTEL_RESERVED_12                 29         // No
#define INTEL_RESERVED_13                 30         // No
#define INTEL_RESERVED_14                 31         // No

#ifndef ASM_SOURCE

#include <arch/task/task.h>
#include <kos/types.h>

#include <idt/idt.h>
 
/* Type of an exception handler */
typedef cpu_state_t* ((*exception_handler_t)(int num_ex,
					       cpu_state_t *cpu_state));

exception_handler_t register_exception_handler(short num_ex,
					       exception_handler_t new_ex);
addr_t get_exception_handler_address(int num_ex);

#endif /* ASM_SOURCE */

#endif /* __exception_h__ */



