/*
 * Copyright (C) 2000, Thomas PETAZZONI, David DECOTIGNY
 * http://kos.enix.org
 *
 * Interrupt Management : main part
 * Bugs corrected by David DECOTIGNY
 * Most of code come from KOS v0.05 (thx to Coffeeman for this code)
 *
 * @(#) $Id: idt.c,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */


#include <loader/mod.h>
#include <lib/stdio.h>
#include <debug/debug.h>
#include <idt/_idt.h>
#include <kos/assert.h>

__init_text static int init_module_level0(kernel_parameter_t *kp) 
{
  UNUSED(kp);
  printk("(init module idt...");

  __dbg_printk("Initializing IDT...\n");
  
  CONCEPTION_ASSERT(sizeof(idt_entry_t) == 8);
  
  _init_idt();

  __dbg_printk("IDT Addr is 0x%x\n", (unsigned) _idt);

  init_irq_management();

  init_dsr();

  printk("Ok)\n");
  return 0;
}

__init_text static int init_module_level5(kernel_parameter_t *kp)
{
  UNUSED(kp);

  init_dst();
  
  return 0;
}


DECLARE_INIT_SYMBOL(init_module_level0, INIT_LEVEL0);
DECLARE_INIT_SYMBOL(init_module_level5, INIT_LEVEL3);

EXPORT_FUNCTION(exception_8_alias);
EXPORT_FUNCTION(register_dsr);
EXPORT_FUNCTION(unregister_dsr);
EXPORT_FUNCTION(mark_dsr);
EXPORT_FUNCTION(get_hw_isr_nested_level);
EXPORT_FUNCTION(register_irq_handler);
EXPORT_FUNCTION(get_irq_handler_address);
EXPORT_FUNCTION(register_exception_handler);
EXPORT_FUNCTION(get_exception_handler_address);
EXPORT_FUNCTION(register_syscall_handler);
EXPORT_FUNCTION(get_syscall_handler_address);
EXPORT_FUNCTION(i8259_disable_irq);
EXPORT_FUNCTION(i8259_enable_irq);
EXPORT_FUNCTION(mark_job);
EXPORT_FUNCTION(new_job);
EXPORT_FUNCTION(del_job);

