/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Include file for irq management
 *
 * @(#) $Id: irq.h,v 1.1.1.1 2003/04/27 12:49:48 thomas Exp $
 */

#ifndef __IRQ_H__
#define __IRQ_H__

#define NUM_IRQ 16

#define IRQ_TIMER                         0
#define IRQ_KEYBOARD                      1
#define IRQ_SLAVE_PIC                     2
#define IRQ_COM2                          3
#define IRQ_COM1                          4
#define IRQ_LPT2                          5
#define IRQ_FLOPPY                        6
#define IRQ_LPT1                          7
#define IRQ_8_NOT_DEFINED                 8
#define IRQ_RESERVED_1                    9
#define IRQ_RESERVED_2                    10
#define IRQ_RESERVED_3                    11
#define IRQ_RESERVED_4                    12
#define IRQ_COPROCESSOR                   13
#define IRQ_HARDDISK                      14
#define IRQ_RESERVED_5                    15

#ifndef ASM_SOURCE

#include <arch/task/task.h>
#include <kos/types.h>
#include <idt/idt.h>

/* Type of an interrupt handler */
typedef void ((*irq_handler_t)(int number,
			       cpu_state_t *cpu_state));

// irq.c
void disable_irq(short numirq);
void enable_irq(short numirq);

irq_handler_t register_irq_handler(short numint,
				   irq_handler_t new_isr);
addr_t get_irq_handler_address(int irq_number);

// assert: spin_lock locked
int get_hw_isr_nested_level(void);


#endif /* ASM_SOURCE */

#endif /* __irq_h__ */



