/*
 * Copyright (C) 2000, Thomas PETAZZONI, David DECOTIGNY
 * http://kos.enix.org
 *
 *
 * @(#) $Id: karm.c,v 1.1 2003/04/27 20:55:55 thomas Exp $
 */

#include <loader/mod.h>
#include <lib/stdio.h>
#include <debug/debug.h>
#include <karm/karm.h>

__init_text static int init_module_level1(kernel_parameter_t *kp)
{
  int result;
  UNUSED(kp);
  printk("(init module karm...");
  
  __dbg_printk("Initialiazing fakefs ...");
  result = fakefs_init();

  if(result < 0)
    {
      __dbg_printk("FAILED : %d\n", result);
      return result;
    }
  else 
    {
      __dbg_printk("Ok\n");
    }

  __dbg_printk("Initializing devfs ...");
  result = devfs_init();

  if(result < 0)
    {
      __dbg_printk("FAILED : %d\n", result);
      return result;
    }
  else 
    {
      __dbg_printk("Ok\n");
    }

  

  printk("done)");
  return 0;
}

DECLARE_INIT_SYMBOL(init_module_level1, INIT_LEVEL1);

EXPORT_FUNCTION(devfs_unregister);
EXPORT_FUNCTION(devfs_register);
EXPORT_FUNCTION(open);
