#include <karm/kres.h>

#include <kmem/kmem.h>
#include <liblist/liblist.h>

#include <kos/assert.h>
#include <kos/macros.h>

/** 
 * Add an user ressource to the list of user ressource of a kernel
 * ressource.
 *
 * @param kres The kernel ressource to which we want to add an user
 *             ressource.
 *
 * @param ures The user ressource we want to add.
 *
 * @return 0 on success, an error code on failure
 */
result_t kres_add_ures(struct kres *kres, struct ures *ures)
{
  list_add_tail(kres->ures_list, ures);
  return 0;
}

/**
 * Delete an user ressource from the list of user ressource of a
 * kernel ressource.
 *
 * @param ures The user ressource to remove.
 *
 * @return 0 on sucess, an error code on failure
 */
result_t kres_remove_ures(struct ures *ures)
{
  list_delete(ures->kres->ures_list, ures);
  return 0;
}

