#ifndef __MOUNT_H__
#define __MOUNT_H__

#include <karm/fs_support.h>
#include <karm/ures.h>
#include <karm/nscache.h>

/** Mount a device with the given filesystem at the given
 *  mountpoint. 
 *
 *   @param device     the device to be mounted. This function assumes
 *                     that this device is opened using the BLOCK 
 *                     interface.
 *   @param mountpoint the string that specifies where the device
 *                     should be monted in the global namespace.
 *   @param fs         the filesystem driver to use to mount the given 
 *                     device.
 *   @param conf       some configuration for the filesystem. It is just
 *                     passed to the attach() function of the filesystem 
 *                     driver for specific configuration.
 *
 *   @return 0 on success, an error code on failure
 */
int mount(struct ures *device, char *mountpoint, struct filesystem *fs,  
	  void *conf);

#endif /* __MOUNT_H__ */
