#ifndef __OPEN_H__
#define __OPEN_H__

#include <karm/ures.h>
#include <kos/types.h>

/** Open an object with a specific interface. The object is specified
    using a location in the global namespace (e.g "/dev/disk/hda"),
    and the interface is specified using an unique interface ID.
    
    @param path      The location of the object to open in the global
                     namespace.

    @param interface The ID of the interface with which we want to
                     open the object.

    @param ures      The location where open() should return the pointer
                     to the new user ressource.

    @return 0 on success, an error code on failure
*/
result_t open(const char *path, unsigned interface, struct ures **ures);

#endif /* __OPEN_H__ */
