#ifndef __VIEW_H__
#define __VIEW_H__

/** Each resource in the system is manipulated through a specific
    point of view defined by the underlying interface */
struct view {
  /** Interface ID of this view (as defined in karm/interface.h) */
  unsigned iid;
  
  /** Number of operations implemented */
  unsigned nb_ops;  
  
  /** The implementation of the interface itself : an array of
      function pointers */
  void     *ops;    
};


#endif /* __VIEW_H__ */
