/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Kgc : kernel garbage collector.
 *
 * @(#) $Id: kgc.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#include <lib/stdio.h>
#include <loader/mod.h>
#include <task/task.h>
#include <debug/debug.h>
#include <kos/macros.h>

/* Kgc main thread */
static void kernel_gc (void *data)
{
  UNUSED(data);

  __dbg_printk("(Kernel garbage collector launched)\n");
  for(;;) {
    /* The thread should now wait, so as to let the system elect a new
       thread. This garbage collector should be called again after
       some delay */
    usleep(1000000);
  }
}


__init_text static int post_init_module_level3 (kernel_parameter_t *kp)
{
  UNUSED(kp);

  printk("(Init module kgc...");

  create_kernel_thread (NULL, kernel_gc, NULL);

  printk("Ok)\n");

  return 0;
}

DECLARE_INIT_SYMBOL(post_init_module_level3, POST_INIT_LEVEL3);


