/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Main source for kitc (kernel inter thread communication) module
 *
 * @(#) $Id: kitc.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#include <loader/mod.h>
#include <kitc/kitc.h>
#include <kos/macros.h>
#include <kitc/_kwaitqueue.h>
#include <kitc/_ksem.h>

__init_text static int init_module_level1(kernel_parameter_t *kp)
{
  UNUSED(kp);

  printk("(Init kitc...");

  if(_kwaitqueue_init() != 0)
    {
      printk("Failed)\n");
      return -1;
    }
  
  if(_ksem_init() != 0)
    {
      printk("Failed)\n");
      return -1;
    }
  printk("Ok)\n");

  return 0;
}

EXPORT_FUNCTION(ksignal_init);
EXPORT_FUNCTION(ksignal_wait);
EXPORT_FUNCTION(ksignal_wakeup);
EXPORT_FUNCTION(ksignal_destroy);

EXPORT_FUNCTION(kmsg_create_port);
EXPORT_FUNCTION(kmsg_delete_port);
EXPORT_FUNCTION(kmsg_send);
EXPORT_FUNCTION(kmsg_receive);
EXPORT_FUNCTION(kmsg_poll);

EXPORT_FUNCTION(kwaitqueue_wake_up);
EXPORT_FUNCTION(kwaitqueue_add);
EXPORT_FUNCTION(kwaitqueue_init);

EXPORT_FUNCTION(ksem_create);
EXPORT_FUNCTION(ksem_destroy);
EXPORT_FUNCTION(ksem_post);
EXPORT_FUNCTION(ksem_wait);
EXPORT_FUNCTION(ksem_getvalue);
EXPORT_FUNCTION(ksem_trywait);

DECLARE_INIT_SYMBOL(init_module_level1, INIT_LEVEL1);
