#ifndef __KMSG_H__
#define __KMSG_H__

#include <kos/spinlock.h>
#include <kitc/ksignal.h>

typedef struct kmsg
{
  void        *msg;
  struct kmsg *next;
  struct kmsg *prev;
}kmsg_t;

typedef struct kmsg_port
{
  struct kmsg *msg_list;

  enum { BLOCKED, UNBLOCKED } receive_state;
  ksig_t     ksig;
  spinlock_t lock;

}kmsg_port_t;


kmsg_port_t *kmsg_create_port(void);
int kmsg_delete_port(kmsg_port_t *kmsg_port);
int kmsg_send(kmsg_port_t *port, void *msg);
void *kmsg_receive(kmsg_port_t *port);
void *kmsg_poll(kmsg_port_t *port);

#endif /* __KMSG_H__ */
