/* ksem.h - Copyright (c) 2002 Thomas Petazzoni, Julien Munier
   ksem public include

   the Kid Operating System (http://kos.enix.org)
   @(#) $Id: ksem.h,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $ */

#ifndef __KSEM_H__
#define __KSEM_H__

/* notice : almost POSIX implementation 
	    pshared not implemented yet!
 */

#include <task/task.h>
#include <kos/spinlock.h>

#define EAGAIN -1

typedef struct ksem {
  enum { SEM_ZOMBIE=0xbadcafe, SEM_READY=0xdeadbeef } state;

  unsigned int mvalue;
  unsigned int value;
  
  spinlock_t lock;

  enum { P_LOCAL=0x0 , P_SHARED=0x22 } type;
  struct thread *waiting_thread_list;
} ksem_t;
 
int ksem_create(struct ksem *, int pshared, unsigned int value);
int ksem_destroy(struct ksem *);

int ksem_post(struct ksem *);

int ksem_wait(struct ksem *);
int ksem_trywait(struct ksem *);

int ksem_getvalue(struct ksem *, int *sval);


#endif /* __KSEM_H__ */
