#include <loader/mod.h>
#include <i8042/i8042.h>
#include <klavier/_klavier.h>
#include <lib/stdio.h>
#include <kos/assert.h>
#include <idt/dsr.h>
#include <kos/macros.h>

extern int ControlKeys;

int _klavier_register(void)
{
  if (_i8042_register_klavier_handler(_klavier) != -1)
    return 0;
  
  return -1;
}

__init_text static int init_module_level4(kernel_parameter_t *kp)
{
  UNUSED(kp);

  printk("(Init module Klavier...");
  ASSERT(_klavier_register() != -1);
  
  register_dsr(1, klavier_dst, (void *) 0xDEADBEEF);
  
  ControlKeys = 0;
  
  printk("Ok)\n");
  return 0;
}


EXPORT_FUNCTION(_klavier);
EXPORT_FUNCTION(register_tty_in_handler);

DECLARE_INIT_SYMBOL(init_module_level4, INIT_LEVEL4);
