#include <kmem/kmem.h>
#include <kmem/_kslab.h>
#include <kmem/_kmem.h>

extern kmem_cache_t kmem_caches[];

void *kmalloc(size_t size)
{
  int i;

  /* Blocks of size <= 2048 bytes are handled by caches */
  if(size <= PAGE_SIZE/2)
    {
      /* Find good cache for the requested size */
      for(i = 0; kmem_caches[i].size != 0; i++)
	if(kmem_caches[i].size >= size)
	  break;
      
      return kslab_cache_alloc(kmem_caches[i].cache);
      
    }

  /* Blocks of size > 2048 bytes are handled by kvmem */
  else
    return (void *) kvalloc(PAGE_ALIGN_SUP(size)/PAGE_SIZE, FALSE, TRUE);
  
  return NULL;
}


