#include <kmem.h>
#include <_kmem.h>
#include <_kslab.h>

extern kmem_cache_t kmem_caches[];

int kfree(void *block)
{
  kslab_slab_t *slab;
  
  slab = __kslab_get_slab(block);

  /* If not slab was found, the block might have been allocated by
     kvmem, try to free it ! */
  if (!slab)
    {
      if(kvfree((addr_t)block, TRUE) < 0)
	return -1;
      else 
	return 0;
    }

  /* Slab was found, free the block */
  if (__kslab_cache_free_by_slab(slab, block) < 0)
    return -1;
  
  return 0;
}

