#include <kmem/kmem.h>
#include <kmem/_kmem.h>
#include <kmem/_kslab.h>
#include <lib/stdio.h>

kmem_cache_t kmem_caches[] = 
{
  { .cache=NULL, .size=4 },
  { .cache=NULL, .size=8 },
  { .cache=NULL, .size=16 },
  { .cache=NULL, .size=32 },
  { .cache=NULL, .size=64 },
  { .cache=NULL, .size=128 },
  { .cache=NULL, .size=256 },
  { .cache=NULL, .size=512 },
  { .cache=NULL, .size=1024 },
  { .cache=NULL, .size=2048 },
  { .cache=NULL, .size=0 }
};


int kmem_init(void)
{
  int i;
  char buffer[32];

  for(i = 0; kmem_caches[i].size != 0; i++)
    {
      snprintf(buffer, 32, "kmalloc-%d", kmem_caches[i].size);
      kmem_caches[i].cache = 
	kslab_cache_create(buffer, kmem_caches[i].size,0,0,0);
      if(kmem_caches[i].cache == NULL)
	return -1;
    }

  return 0;
}
