/*
 * Copyright (C) 2000, Thomas Petazzoni
 * http://kos.enix.org
 *
 * Destroy a cache in the kslab allocator
 *
 * @(#) $Id: _kslab_cache_destroy.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */
#include <_kslab.h>
#include <liblist/liblist.h>
#include <kos/spinlock.h>

int kslab_cache_destroy(kslab_cache_t *cache)
{
  k_ui32_t flags;

  /* Make sure there's nothing in the cache */
  if(cache->full != NULL || cache->semi_full != NULL)
    return -1;
  
  /* Remove the cache from the list */
  write_spin_lock(kernel_kslab_lock, flags);
  list_delete(kslab_cache_list, cache);
  write_spin_unlock(kernel_kslab_lock, flags);

  /* Delete the cache structure */
  if(kslab_cache_free(&cache_of_kslab_cache, cache) < 0)
    return -1;
  
  return 0;
}
