/* /include/kos/asm.h
 * @(#) $Id: asm.h,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 * Description : definition de quelques macros ASM utiles sous djgpp
 * Auteurs : Coffeeman
 * Bugs connus : Aucun
*/
#ifndef __ASM_H__
#define __ASM_H__

// write value on port
#define outb(value, port)					\
  __asm__ volatile (	       					\
	"outb %b0,%w1"						\
	::"a" (value),"Nd" (port)				\
	)							\

// write value (word) on port
#define outw(value, port)					\
  __asm__ volatile (	       					\
	"outw %w0,%w1"						\
	::"a" (value),"Nd" (port)				\
	)							\

// write value (long) on port
#define outl(value, port)					\
  __asm__ volatile (   						\
	"outl %l0,%w1"						\
	::"a" (value),"Nd" (port)				\
	)							\

// read one byte from port
#define inb(port)						\
({								\
  unsigned char _v;						\
  __asm__ volatile (						\
	"inb %w1,%0"						\
	:"=a" (_v)						\
	:"Nd" (port)						\
	);							\
  _v;								\
})

// read one word from port
#define inw(port)						\
({								\
  unsigned int _v;						\
  __asm__ volatile (						\
	"inw %w1,%w0"						\
	:"=a" (_v)						\
	:"Nd" (port)						\
	);							\
  _v;								\
})

// read one long from port
#define inl(port)						\
({								\
  unsigned long _v;						\
  __asm__ volatile (						\
	"inl %w1,%0"					        \
	:"=a" (_v)						\
	:"Nd" (port)						\
	);							\
  _v;								\
})


#endif /*__ASM_H__ */
