/* /include/kos/system.h
 * @(#) $Id: system.h,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 * Description : memory mapping
 * Auteurs : David Decotigny, Julien Munier, Thomas Petazzoni 
 * Bugs connus : Aucun
*/
#ifndef __SYSTEM_H__
#define __SYSTEM_H__

#define HZ 1000

#define MAX_KERNEL_THREAD_NUMBER 256
#define MAX_USER_THREAD_NUMBER   4096
#define MAX_TEAM_NUMBER          1024

#define CORE_KERNEL_VIRTUAL_ADDR              (768*1024*1024)  /* 768M (ie enough room for 64GB RAM GPFM) */
#define CORE_KERNEL_VIRTUAL_SIZE              (128*1024*1024)  /* 128M */
#define CPL0_KERNEL_STACK_VIRTUAL_ADDR        (1024*1024*1024) /* 1G */
#define CPL0_KERNEL_STACK_VIRTUAL_SIZE        (3*PAGE_SIZE)    /* 12K */
#define CPL0_KERNEL_STACK_PHYSICAL_SIZE       (2*PAGE_SIZE)    /* 8K */
#define CPL0_KERNEL_STACK_VIRTUAL_REGION_SIZE (CPL0_KERNEL_STACK_VIRTUAL_SIZE \
                                              * MAX_KERNEL_THREAD_NUMBER)

//32M free between kernel and cpl0 user stacks
#define CPL0_USER_STACK_VIRTUAL_ADDR   \
                         (CPL0_KERNEL_STACK_VIRTUAL_ADDR \
                         + CPL0_KERNEL_STACK_VIRTUAL_REGION_SIZE \
                         + 32*1024*1024)
#define CPL0_USER_STACK_VIRTUAL_SIZE   \
                         CPL0_KERNEL_STACK_VIRTUAL_SIZE
#define CPL0_USER_STACK_PHYSICAL_SIZE \
                         CPL0_KERNEL_STACK_PHYSICAL_SIZE
#define CPL0_USER_STACK_VIRTUAL_REGION_SIZE \
                         (CPL0_USER_STACK_VIRTUAL_SIZE \
                         * MAX_USER_THREAD_NUMBER)

#define USER_SPACE_START (2UL*1024*1024*1024)             /* 2G */
#define CPL3_HEAP_ADDR   (USER_SPACE_START+512*1024*1024) /* 2.5 G */
#define CPL3_HEAP_SIZE   (512*1024*1024)                  /* 512 M */
#define CPL3_CODE_ADDR   (USER_SPACE_START+128*1024*1024+4096) /* 2G+128M+PAGE_SIZE */

#endif /*__SYSTEM_H__ */
