#include <loader/mod.h>
#include <kos/macros.h>
#include <init/init.h>
#include <debug/debug.h>
#include <lib/stdio.h>
#include <task/task.h>
#include <kos/system.h>
#include <kos/asm.h>
#include <task/task.h>
#include <kos/assert.h>
#include <elf/elf.h>
#include <lib/string.h>
#include <pmm/pmm.h>
#include <lib/libcmdline.h>


#define _S_KOS "KOS is really the best"
char * kos_logo_str = "

+-----+ +-----+ +-----+
|  |  | |     | |  |  |
|--+  | |  +--| |--|--|
|     | |  |  | |  |  |
+-----+ +-----+ +-----+

The Kid Operating System
http://kos.enix.org/\n\n
";

volatile unsigned char *screen;

/* This is just an example of how to call a function with a variable
   number of arguments. */
#if 0
static int call_anon(int (*func)(), int nb_args, int *args)
{
	int i, *dst = __builtin_alloca(nb_args*sizeof(int));
	for (i = 0 ; i < nb_args ; i++)
		dst[i] = args[i];
	return func();
}
#endif

static int logo_disp (void)
{
  printk(kos_logo_str);
  return 0;
}

static void thread_twiddle (void *data)
{
  int tid = (int)data;
  static char *pos = _S_KOS;
  volatile unsigned char *twiddle = (unsigned char *) (screen + (130+tid)*2);

  while(TRUE) {
    *(twiddle + 1) = 4;
    (*twiddle) = *pos;
    if (*(++pos) == '\0')
      pos = _S_KOS;
  }
}

static void thread_idle(void *data)
{
  UNUSED(data);
  for(;;);
}

/* remount_root
 *
 * This function aims at mounting the root filesystem
 *
 * kp : the kernel parameters
 *
 * Returns 0 on success, an error code on failure
 */

static int remount_root(kernel_parameter_t *kp)
{
  UNUSED(kp);

  
  
  return 0;
}

/* load_init
 *
 * This is the main kernel thread, which should run everything 
 *
 * data : data for the thread. In our case, it is a pointer to a
 * string which is the command line.
 * 
 * Returns nothing
 */
static void load_init(void *data)
{
  char *config;

  ASSERT_FATAL(data != NULL);

  config = (char *) data;

  logo_disp();

  for(;;);

  return;
}

static void build_system(kernel_parameter_t *kp)
{
  team_t *team;
  char *init;

  UNUSED(kp);

  team = create_team();
  if (!team)
    FAILED_VERBOSE("Error when creating the new team.\n");
   

  init = cmdline_get_module_parameters(kp,"wolfgang","init"); 
  if (!init)
    FAILED_VERBOSE("Error no init given as parameter, can't load the system.\n");

  if (create_kernel_thread(team, load_init, (void *)init) == NULL)
    FAILED_VERBOSE("Error when creating thread (load_init).\n");;
}

static void primary_thread (kernel_parameter_t *kp)
{
  __dbg_enable_output(DEBUG_BOCHS);  

  create_kernel_thread(NULL, thread_idle, NULL);
  kernel_post_init(kp);
  create_kernel_thread(NULL, thread_twiddle, (void *)12);

  if (remount_root(kp))
    FAILED_VERBOSE("Error when mounting the root\n");
  
  // TBI :
  // Remove space used by  :
  //    - The bootstrap stack
  //    - The init module

  build_system(kp);
}


KERNEL_START(kernel_parameter_t *kp)
{
  thread_t *primary_thread_id;

  /* HZ is defined in modules/kos/system.h */
  set_timer_frequency (HZ);

  screen = (unsigned char *) kp->video_memory;

  primary_thread_id = create_kernel_thread(get_kernel_team(), 
					   (kernel_thread_fct_t*)primary_thread, (void*)kp);
  primary_thread_id->state = RUNNING;
  set_current_thread(primary_thread_id);
  cpl0_switch_no_return(primary_thread_id->cpu_context.cpl0);

  FAILED_VERBOSE("NEVER REACHED !\n");
  
  return 123;
}


