/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Standard string functions : str(n)cat
 *
 * @(#) $Id: strcat.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#include <loader/mod.h>
#include <lib/string.h>
#include <kos/types.h>
#include <kos/macros.h>
#include <kos/assert.h>

EXPORT_FUNCTION(strcat);
EXPORT_FUNCTION(strncat);


char *strcat (char *dest, const char *src)
{
  char *res = dest;

  for ( ; *dest ; dest++);

  for ( ; *src ; src++, dest++)
    *dest = *src;
  *dest = '\0';

  return res;
}


char *strncat (char *dest, const char *src, size_t n)
{
  char *res = dest;

  for ( ; *dest ; dest++);

  for ( ; *src ; src++, dest++) {
    *dest = *src;
    n--;
    if (n <= 0)
      break;
  }
  *dest = '\0';

  return res;
}

