/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Standard string functions : str(n)cmp
 *
 * @(#) $Id: strcmp.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#include <loader/mod.h>
#include <lib/string.h>
#include <kos/types.h>
#include <kos/macros.h>
#include <kos/assert.h>

EXPORT_FUNCTION(strcmp);
EXPORT_FUNCTION(strncmp);


int strcmp(register const char *s1, register const char *s2)
{
    while (*s1 == *s2++)
      if (*s1++ == 0)
        return (0);
    
    return (*(const unsigned char *)s1 - *(const unsigned char *)(s2 - 1));
}


int strncmp(register const char *s1, register const char *s2, register int len)
{
  char c1 = '\0', c2 = '\0';

  while (len > 0)
    {
      c1 = (unsigned char) *s1++;
      c2 = (unsigned char) *s2++;
      if (c1 == '\0' || c1 != c2)
        return c1 - c2;
      len--;
    }

  return c1 - c2;
}
