/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Standard string functions : str(n)cpy
 *
 * @(#) $Id: strcpy.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#include <loader/mod.h>
#include <lib/string.h>
#include <kos/types.h>
#include <kos/macros.h>
#include <kos/assert.h>

EXPORT_FUNCTION(strcpy);
EXPORT_FUNCTION(strzcpy);
EXPORT_FUNCTION(strncpy);

char *strcpy(register char *dst, register const char *src)
{
        char *tmp = dst;

        while (*src)
          *(dst++) = *(src++);

        *(dst) = '\0';
        return tmp;
}


char *strzcpy(register char *dst, register const char *src, register int len)
{
        char *tmp = dst;

        while ((len-- > 0) && (*src))
          *(dst++) = *(src++);

        *(dst) = '\0';
        
        return tmp;
}

char *strncpy(register char *dst, register const char *src, register int len)
{
        char *tmp = dst;

        while ((len-- >= 0) && (*src))
          *(dst++) = *(src++);

        return tmp;
}
