
#include <loader/mod.h>
#include <lib/string.h>
#include <kos/types.h>
#include <kos/macros.h>
#include <kos/assert.h>
#include <kmem/kmem.h>

/** strndup works like strdup() but it only  copies  the
    first  size  bytes. It always add a NUL terminator */
inline char *strndup(const char* src, const size_t size)
{
  char *dest;
  if (! src)
    return NULL;

  dest = kmalloc(size+1);
  if (! dest)
    return NULL;

  memcpy(dest, src, size);
  dest[size]='\0';

  return dest;
}

char * strdup(const char* src)
{
  if (! src)
    return NULL;
  return strndup(src, strlen(src));
}


EXPORT_FUNCTION(strndup);
EXPORT_FUNCTION(strdup);
