/*
 * Copyright (C) 2000
 * http://kos.enix.org                 
 * 
 * Header for standard string functions.
 * 
 * @(#) $Id: string.h,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */


#ifndef __KOS_STRING_H__
#define __KOS_STRING_H__

#include <kos/types.h>

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

void *memcpy( void *dst0, const void *src0, register unsigned int size ) ;
void *memset( void *dst0, register int c0, register unsigned int length ) ;
void *memchr(const void *s, int c_in, size_t n);


char *strdup(const char* src);
/** strndup works like strdup() but it only  copies  the
    first  size  bytes. It always add a NUL terminator */
char *strndup(const char* src, const size_t size);

unsigned int strlen( register const char *str ) ;
unsigned int strnlen(const char * s, size_t count);
char * strchr (const char *s, int c_in);
char *strrchr(const char *p, int ch);

char *strcpy( register char *dst, register const char *src ) ;
char *strncpy( register char *dst, register const char *src,
	       register int len ) ;

/**
 * @note Same as strncpy(), with a slightly different semantic.
 * Actually, strncpy(3C) says " The result will not be null-terminated
 * if the length of 'from' is n or more.".  Here, 'dst' is ALWAYS
 * null-terminated. And its total len will ALWAYS be <= len, with
 * null-terminating-char included.  */
char *strzcpy( register char *dst, register const char *src,
	       register int len ) ;

char *strcat (char *dest, const char *src);
char *strncat (char *dest, const char *src, size_t n);

int strcmp( register const char *s1, register const char *s2 );
int strncmp( register const char *s1, register const char *s2,
	     register int len );

#ifdef __cplusplus
}
#endif /* __cpluscplus */

#endif /* __KOS_STRING_H__ */
