/*
 * Copyright (C) 2000, David DECOTIGNY & Thomas PETAZZONI 
 * http://kos.enix.org
 *
 * Header for splay trees library
 *
 * @(#) $Id: _splay.h,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#ifndef ___SPLAY_H__
#define ___SPLAY_H__

#include <libbst/libbst.h>

struct tree_node *_splay_insert_node(struct tree_node *new_node, 
				     struct tree_node *tree);
struct tree_node *_splay_delete_node(struct tree_node *remove_node, 
				     struct tree_node *tree);


/* Walk through node calling visitor for each node. We stop the
   walk-through as soon as visitor returns TRUE, and return the
   corresponding node */
struct tree_node * _splay_visit(struct tree_node *node, 
				visitor_t visitor, 
				void *client_data);
struct tree_node *_splay_lookup (tree_node_t *tree,
				 compare_fct_t compare_fct,
				 void *client_data);

/* This visitor should be used to unallocate each node of the given tree */
int _splay_reset (tree_node_t *tree,
		  visitor_t cleaner,
		  void *user_data);


#endif /* ___SPLAY_H__ */
