#include <stdlib.h>
#include <stdio.h>

#include "splay_lib.h"

#define ARRAY_SIZE (512*1024)

#undef BOUND_CHECK

int add_array[ARRAY_SIZE], del_array[ARRAY_SIZE];
tree_node_t node_array[ARRAY_SIZE];

inline static int rnd_int(int rnd_max)
{
  return random() % rnd_max;
}


void rnd_array(int *array, int nb_items)
{
  int i;

  for (i = 0 ; i < nb_items ; i++)
    array[i] = -1;

  for (i = 0 ; i < nb_items ; i++) {
    int index;
    printf("\r%d", i);
    /* On va essayer de caser i dans une case, tiree aleatoirement, de
       array */
    index = rnd_int(nb_items);
    if (array[index] >= 0) {
      /* Mince, c'est deja pris */
      /* On choisit une direction, et on prend le premier emplacement
         libre */
      if (random() > (RAND_MAX >> 1)) {
	while (array[index] >= 0) {
	  index++;
	  if (index >= nb_items)
	    index = 0;
	}
      } else {
	while (array[index] >= 0) {
	  index--;
	  if (index < 0)
	    index = nb_items - 1;
	}
      }
    }
    array[index] = i;
  }

  printf("\r");
}

void dump_array(int *int_array, int nb_items) {
  int i;

  for (i = 0 ; i < ARRAY_SIZE ; i++) {
    printf("%7d", int_array[i]);
    if ((i+1) % 10)
      printf(" ");
    else
      printf("\n");
  }
  printf("\n");
}


static int print_node(tree_node_t *node, void *ignored)
{
  //  printf("%d <- Node(%d) -> %d\n", (node->left)?node->left->key:-1,
  //	 node->key, (node->right)?node->right->key:-1);
  printf("%7d ", node->key);
  return 0;
}


int main(void) 
{
  tree_node_t *tree;
  int i;

  printf("[ Test sur %d elements ]\n", ARRAY_SIZE);

  printf("Gen add array...\n"); fflush(stdout);
  rnd_array(add_array, ARRAY_SIZE);
  printf("Gen del array...\n"); fflush(stdout);
  rnd_array(del_array, ARRAY_SIZE);

  tree = NULL;

  /* On ajoute tout ce qu'on trouve */
  printf("Ajout tout add-array...\n");
  for (i = 0 ; i < ARRAY_SIZE ; i++) {
    printf("\r%d", i); fflush(stdout);
    node_array[i].key = add_array[i];
    tree = insert_node(node_array + i, tree);
    if (! tree) {
      printf("Add impossible pour %d !!!\n", i);
      exit(-1);
    }
  }

  visit(tree, print_node, NULL); printf("\n");

  /* On verifie qu'on a bien tout */
  printf("\rVerif tout a ete correctement insere...\n");
  for (i = 0 ; i < ARRAY_SIZE ; i++) {
    printf("\r%d", i); fflush(stdout);
    tree = splay_node(i, tree);
    if (! tree) {
      printf("Noeud %d introuvable !!!\n", i);
      exit(-1);
    }
  }

  visit(tree, print_node, NULL); printf("\n");

  printf("\rSuppression de tout...\n");
  for (i = 0 ; i < ARRAY_SIZE ; i++) {
    printf("\r%d", i); fflush(stdout);
    tree = delete_node(node_array + del_array[i], tree);
    if ((! tree)
	&& (i < (ARRAY_SIZE-1))) /* Quqnd on enleve le dernier
                                    element, ca retourne NULL et c'est
                                    NORMAL ! */
    {
      printf("Impossible d'enlever %d !!!\n", del_array[i]);
      exit(-1);
    }
  }
  printf("\rOk !                \n");

  return 0;
}
