/* Offline test for list.h */

#include "liblist.h"
#include <stdio.h>

struct node 
{
  int key;
  struct node *prev;
  struct node *next;
};
typedef struct node node_t;

#define N 10

node_t *list1, _list1[N];
node_t *list2, _list2[N];

int main(void)
{
  int i;
  node_t *n;

  for (i = 0 ; i < N ; i++) {
    _list1[i].key = i;
    _list2[i].key = i + N;
  }

  list1 = NULL;
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);
  
  list_add_tail(list1, _list1 + 0);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_add_tail(list1, _list1 + 1);
  list_add_tail(list1, _list1 + 2);
  list_add_tail(list1, _list1 + 3);
  list_add_tail(list1, _list1 + 4);
  list_add_head(list1, _list1 + 5);
  list_add_head(list1, _list1 + 6);
  list_add_head(list1, _list1 + 7);
  list_add_head(list1, _list1 + 8); 
  list_add_head(list1, _list1 + 9);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);
  list_delete(list1, _list1 + 5);
  list_delete(list1, _list1 + 6);
  list_delete(list1, _list1 + 4);
  list_add_tail(list1, _list1 + 5);
  list_delete(list1, _list1 + 9);
  list_delete(list1, _list1 + 2);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_delete(list1, _list1 + 0);
  list_delete(list1, _list1 + 3);
  list_delete(list1, _list1 + 7);
  list_delete(list1, _list1 + 1);
  list_delete(list1, _list1 + 8);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_delete(list1, _list1 + 5);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_add_head(list1, _list1 + 9);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_add_head(list1, _list1 + 5);
  list_add_tail(list1, _list1 + 4);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_delete(list1, _list1 + 5);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_collapse(list1, n)
    ;
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  /* Test splice */
  printf("Test splice 9+9...\n");

  list_add_tail(list1, _list1 + 1);
  list_add_tail(list1, _list1 + 2);
  list_add_tail(list1, _list1 + 3);
  list_add_tail(list1, _list1 + 4);
  list_add_head(list1, _list1 + 5);
  list_add_head(list1, _list1 + 6);
  list_add_head(list1, _list1 + 7);
  list_add_head(list1, _list1 + 8); 
  list_add_head(list1, _list1 + 9);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_add_tail(list2, _list2 + 1);
  list_add_tail(list2, _list2 + 2);
  list_add_tail(list2, _list2 + 3);
  list_add_tail(list2, _list2 + 4);
  list_add_head(list2, _list2 + 5);
  list_add_head(list2, _list2 + 6);
  list_add_head(list2, _list2 + 7);
  list_add_head(list2, _list2 + 8); 
  list_add_head(list2, _list2 + 9);
  list_foreach(list2, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  list_splice_tail(list1, list2);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);
  list_foreach_backward(list2, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);

  /* Test splice */
  printf("Test splice 1+1...\n");

  list_init(list1, _list1 + 0);
  list_init(list2, _list2 + 0);
  list_splice_tail(list1, list2);
  list_foreach(list1, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);
  list_foreach(list2, n, i)
    printf("-[%d]-", n->key);
  printf("  (%d elts)\n", i);
 
  return 0;
}


