#ifndef __PART_H__
#define __PART_H__

#include <babel/tower/tower.h>

/* _part.c
 */
int _part_request_for_registering(struct translator *trans, size_t blk_size);

typedef struct part_translator {
  struct translator parent;

  enum { ACTIVE, NOT_ACTIVE } is_active;
  int      number;
  k_ui8_t  fs_type;

  k_ui32_t start;
  k_ui32_t size;
  k_ui32_t blk_size;

  /* Harddisk on which the partition is */
  struct shadow_resource *hd;

} part_translator_t;

typedef struct part_kernel_methods_table {
  struct kernel_methods_table parent;
  int (*mount)(struct shadow_resource *sr, char *mount_point, char *fstype, int flags);
} part_kernel_methods_table_t;


typedef struct part_mt {
  int (*mount)(struct resource *res, char *mount_point, char *fstype, int flags);
  int (*read)(struct resource *res, char *buf, offset_t offset, size_t len);
  int (*write)(struct resource *res, char *buf, offset_t offset, size_t len);
} part_mt_t;


#endif /* __PART_H__ */
