/*
 * Copyright (C) 2000
 * http://kos.enix.org
 *
 * Scheduler module init/cleanup routines
 *
 * @(#) $Id: scheduler.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */


#include <loader/mod.h>
#include <scheduler/_scheduler.h>

extern unsigned char *twiddle;

__init_text static int init_module_level3 (kernel_parameter_t *kp)
{
  if(init_timer() < 0)
    return -1;

  twiddle = (unsigned char *) (kp->video_memory + 79*2);
  
  return 0;
}

__init_text static int post_init_module_level0 (kernel_parameter_t *kp)
{
  UNUSED(kp);

  printk("(init module sched... ");
  init_delay_loop();
  printk(" Ok)\n");

  return 0;
}


EXPORT_FUNCTION(usleep);
EXPORT_FUNCTION(udelay);
EXPORT_FUNCTION(reschedule_after_interrupt);
EXPORT_FUNCTION(reschedule_run_next);
EXPORT_FUNCTION(timer_handler);
EXPORT_FUNCTION(reschedule_unsafe);
EXPORT_FUNCTION(get_jiffies);


DECLARE_INIT_SYMBOL(init_module_level3, INIT_LEVEL3);
DECLARE_INIT_SYMBOL(post_init_module_level0, POST_INIT_LEVEL0);




