/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Private declarations for task management (portable part)
 *
 * @(#) $Id: _task.h,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */


#ifndef ___TASK_H__
#define ___TASK_H__

#include <loader/mod.h>
#include <kmem/kmem.h>
#include <task/task.h>

/* Private variables */

extern struct thread *current_thread;
extern team_t *kernel_team;
extern addr_t thread_end_handler_stack;
extern struct thread *thread_global_list;
extern struct team   *team_global_list;
extern struct kslab_cache *kmem_team_cache;

/* Private functions */

void unallocate_cpl0_stack (thread_t *thread);
int  allocate_cpl0_stack (thread_t *thread);
void register_thread (thread_t *thread, team_t *team);
void unregister_thread (thread_t *thread);
__init_text int init_cpl0_stacks_regions (void);
__init_text void init_thread_end_handler (void);
__init_text int create_initial_regions (kernel_parameter_t *kp);
__init_text int init_team_subsystem (kernel_parameter_t *kp);



#endif
