/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Initialization functions for the task module
 *
 * @(#) $Id: _task_init.c,v 1.2 2003/04/27 20:55:55 thomas Exp $
 */
 

#include <task/_task.h>
#include <kos/system.h>
#include <kos/assert.h>
#include <kmem/kmem.h>
#include <arch/mm/mm.h>
#include <kos/macros.h>
#include <liblist/liblist.h>

__init_text void init_thread_end_handler (void)
{
  thread_end_handler_stack = kvalloc(1, FALSE, TRUE);
  
  if(!thread_end_handler_stack)
    FAILED_VERBOSE("No more physical page for stack !\n");

  thread_end_handler_stack += PAGE_SIZE-1;
}


struct kslab_cache *kmem_team_cache;  

__init_text int init_team_subsystem (kernel_parameter_t *kp)
{
  UNUSED(kp);

  kmem_team_cache = kslab_cache_create("kmem_team_cache",
				       sizeof(team_t),
				       0, 0, 0);
  if (! kmem_team_cache)
    return -1;

  kernel_team = kslab_cache_alloc(kmem_team_cache);
  if (!kernel_team)
    FAILED_VERBOSE("(init_module) task.c Allocation failed\n");

  /* Init of kernel team */
  kernel_team->thread_list = NULL;

  list_add_tail(team_global_list, kernel_team);

  if (arch_init_kteam_mm_context(& kernel_team->mm_context))
    FAILED_VERBOSE("(init_module) init kteam mm context failed\n");

  /* Create various virtual regions for the kernel team */
  if (init_team_as(kernel_team))
    FAILED_VERBOSE("(init_module) init kteam address space failed\n");  

  return 0;
}
