/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 * Common functions to kernel and user thread management.
 *
 * @(#) $Id: _task_thread.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */

#include <task/_task.h>
#include <kos/system.h>
#include <kos/assert.h>
#include <liblist/liblist.h>

void register_thread (thread_t *thread, team_t *team)
{

  /* Add to global list */
  list_add_tail_named(thread_global_list,
		      thread, 
		      prev_global,
		      next_global);

  /* Add to team's list */
  list_add_tail_named(team->thread_list,
		      thread,
		      prev_in_team,
		      next_in_team);
}


void unregister_thread (thread_t *thread)
{  
  /* Remove from global list */
  list_delete_named(thread_global_list,
		    thread,
		    prev_global,
		    next_global);
  
  
  /* Remove from team's list */
  list_delete_named(thread->mother_team->thread_list,
		    thread,
		    prev_in_team,
		    next_in_team);
}
