#include <loader/mod.h>
#include <lib/stdio.h>
#include <vmm/vmm.h>
#include <kos/spinlock.h>

#include <task/_task.h>

__init_text static int init_module_level2(kernel_parameter_t *kp)
{
  UNUSED(kp);

  current_thread = NULL;

  printk("(init team subsystem...");
  if (init_team_subsystem(kp))
    return -1;
  printk("Ok)\n");

  printk("(init cpl0 stack regions...");
  if (init_cpl0_stacks_regions())
    return -1;
  printk("Ok)\n");

  show_all_thread_info();

  init_thread_end_handler();

  return 0;
}

EXPORT_FUNCTION(thread_end_handler);
EXPORT_FUNCTION(get_kernel_team);
EXPORT_FUNCTION(get_current_thread);
EXPORT_FUNCTION(set_current_thread);
EXPORT_FUNCTION(get_global_thread_list_head);
EXPORT_FUNCTION(show_all_thread_info);
EXPORT_FUNCTION(create_team);
EXPORT_FUNCTION(_create_kernel_thread);

DECLARE_INIT_SYMBOL(init_module_level2, INIT_LEVEL2);

SPINLOCK(kernel_thread_list_lock);
SPINLOCK(kernel_team_list_lock);
EXPORT_SPINLOCK(kernel_thread_list_lock);
EXPORT_SPINLOCK(kernel_team_list_lock);
