#include <loader/mod.h>
#include <lib/stdio.h>

#include <vmm/_vmm.h>

__init_text static int init_module_level1(kernel_parameter_t *kp)
{
  UNUSED(kp);
  
  printk("(Init vmm");
  
  printk(" as");
  if (__init_as_engine())
    {
      printk("...Failed)\n ");
      return -1;
    }

  printk(" vr");
  if (__init_vr_engine())
    {
      printk("...Failed)\n ");
      return -1;
    }

  printk(" kmem");
  if(__init_kmem_resource())
    {
      printk("...Failed)\n ");
      return -1;
    }

  printk("... Ok)\n");
  
  return 0;
}


EXPORT_FUNCTION(as_init);
EXPORT_FUNCTION(as_cleanup);
EXPORT_FUNCTION(as_dup_vr_tree);
EXPORT_FUNCTION(as_map_kres);
EXPORT_FUNCTION(as_remove_vr);
EXPORT_FUNCTION(as_page_fault);
EXPORT_FUNCTION(as_resize_vr);
EXPORT_FUNCTION(as_dump);

EXPORT_FUNCTION(vr_new);
EXPORT_FUNCTION(vr_del);

EXPORT_FUNCTION(map_virtual_page);
EXPORT_FUNCTION(unmap_virtual_page);
EXPORT_FUNCTION(unmap_virtual_range);
EXPORT_FUNCTION(protect_virtual_page);

EXPORT_FUNCTION(init_team_as);

DECLARE_INIT_SYMBOL(init_module_level1, INIT_LEVEL1);
