#include "bitmap.h"

#define BSF inl_bsf

inline static unsigned short inl_bsf(unsigned long bitfield)
{
  unsigned long res;
  
  asm("bsfl %1,%0" : "=q" (res) : "q" (bitfield));
  return res;
}


/* Size in bytes, aligned on a 4-bytes boundary */
/* Returns the number of the first set bit in the bitmap */
size_t bsf_bitmap (addr_t bitmap, size_t size)
{
  size_t i;


  for (i = 0; i < size; i += 4)
    {
      unsigned *word = (unsigned *)(bitmap + i);

      if(*word == 0)
	continue; /* no space left */

      return (CHAR_BITS * i) + BSF (*word);
    }
  return size*CHAR_BITS + 1;
}

/* Position in bits */
void set_bit_in_bitmap (addr_t bitmap, size_t position, int value)
{
  /* equivalent to data = bitmap + position/32 */
  unsigned *data = (unsigned *)(bitmap + ((position >> 5) << 2));

  /* equivalent to position = position % 32 */
  position &= 0x1f;

  if (value)
    *data |= 1 << position;
  else
    *data &= ~(1 << position);

}

int get_bit_in_bitmap (addr_t bitmap, size_t position)
{
  /* equivalent to data = bitmap + position/32 */
  unsigned *data = (unsigned *)(bitmap + ((position >> 5) << 2));

  /* equivalent to position = position % 32 */
  position &= 0x1f;

  return (*data & (1 << position));
}

