/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 *
 * @(#) $Id: _cpl0_switch.S,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */
#define ASM_SOURCE 1

	.file "_cpl0_switch.S"

/*
 * Assembler source for -fomit-frame-pointer considerations, since gcc
 * doesn't handle esp as a clobbered register (in inline asm)
 */

.text
	
/* The interrupts are set in the state in which they were set by the
   to_context (no brute force sti) */

/* void cpl0_switch_no_return (cpu_state_t *cpu_state) */
.globl cpl0_switch_no_return
.type cpl0_switch_no_return, @function
cpl0_switch_no_return:
	// cpu_state  -- esp+4
	// caller ip    -- esp
  movl 0x4(%esp),%eax
  movl %eax,%esp
  popw %gs
  popw %fs
  popw %es
  popw %ds
  popw %ss
  addl $2,%esp
  popl %eax
  popl %ebx
  popl %ecx
  popl %edx
  popl %esi
  popl %edi
  popl %ebp
  addl $4, %esp
  iret


/* This function must only be called by reschedule_run_next The
   interrupts are set in the state in which they were set by the
   to_context (no brute force sti) */
/* void cpl0_switch_with_return (cpu_state_t **from_context, 
			         cpu_state_t *to_context) */
.globl cpl0_switch_with_return
.type cpl0_switch_with_return, @function
cpl0_switch_with_return:
	// arg2= to_context    -- esp+64
	// arg1= from_context  -- esp+60
	// caller ip           -- esp+56
  pushf              // esp+52
  pushl %cs          // esp+48
  pushl $get_there   // esp+44
  pushl $0           // esp+40
  pushl %ebp         // esp+36
  pushl %edi         // esp+32
  pushl %esi         // esp+28
  pushl %edx         // esp+24
  pushl %ecx         // esp+20
  pushl %ebx         // esp+16
  pushl %eax         // esp+12
  subl $2, %esp      // esp+10
  pushw %ss          // esp+8
  pushw %ds          // esp+6
  pushw %es          // esp+4
  pushw %fs          // esp+2
  pushw %gs          // esp
  movl  %esp, %eax
  movl  60(%eax), %ebx
  movl  %esp, (%ebx)

//  pushl (%ebx)
//  call dump_cpu_state

//  pushl 64(%eax)
//  call dump_cpu_state
//  addl $4, %esp
// 1: jmp 1b

  movl 64(%eax), %esp
  popw %gs
//1: jmp 1b
  popw %fs
  popw %es
  popw %ds
  popw %ss
  addl $2,%esp
  popl %eax
  popl %ebx
  popl %ecx
  popl %edx
  popl %esi
  popl %edi
  popl %ebp
  addl $4, %esp
  iret

get_there:
  ret
