/*
 * Copyright (C) 2000, Thomas PETAZZONI
 * http://kos.enix.org
 *
 *
 * @(#) $Id: _dump.c,v 1.1.1.1 2003/04/27 12:49:49 thomas Exp $
 */
#include <debug/debug.h>
#include "_task.h"

void dump_cpu_state(cpu_state_t *cpu_state)
{
  __dbg_printk("*** Dumping CPU Context ***\n");
  __dbg_printk("| ESP    = 0x%x\n", (unsigned) cpu_state);
  __dbg_printk("| EIP    = 0x%x\n", cpu_state->eip);
  __dbg_printk("| CS     = 0x%x\n", cpu_state->cs);
  __dbg_printk("| EFLAGS = 0x%x\n", cpu_state->eflags);
  __dbg_printk("| EAX    = 0x%x\n", cpu_state->eax);
  __dbg_printk("| EBX    = 0x%x\n", cpu_state->ebx);
  __dbg_printk("| ECX    = 0x%x\n", cpu_state->ecx);
  __dbg_printk("| EDX    = 0x%x\n", cpu_state->edx);
  __dbg_printk("| ESI    = 0x%x\n", cpu_state->esi);
  __dbg_printk("| EDI    = 0x%x\n", cpu_state->edi);
  __dbg_printk("| DS     = 0x%x\n", cpu_state->ds);
  __dbg_printk("| ES     = 0x%x\n", cpu_state->es);
  __dbg_printk("| FS     = 0x%x\n", cpu_state->fs);
  __dbg_printk("| GS     = 0x%x\n", cpu_state->gs);
  __dbg_printk("| SS     = 0x%x\n", cpu_state->ss);
  __dbg_printk("*** End of CPU Context ***\n");
}


void dump_tss(char *tss_name, tss_t *tss)
{
  __dbg_printk("[ Dump of %s TSS (0x%x) ]\n", tss_name, (unsigned)tss);
#define TSSFIELD16(field) \
    __dbg_printk("  " #field "=0x%x\n", (unsigned)(tss->field & 0xffff));
#define TSSFIELD32(field) \
    __dbg_printk("  " #field "=0x%x\n", (unsigned)tss->field);
    // TSSFIELD16(back_link);
    // TSSFIELD16(reserved1);
    // TSSFIELD32(esp0);
    // TSSFIELD16(ss0);
    // TSSFIELD16(reserved2);
    // TSSFIELD32(esp1);
    // TSSFIELD16(ss1);
    // TSSFIELD16(reserved3);
    // TSSFIELD32(esp2);
    // TSSFIELD16(ss2);
    // TSSFIELD16(reserved4);
    TSSFIELD32(cr3);
    TSSFIELD32(eip);
    __dbg_lookup_sym(tss->eip);
    TSSFIELD32(eflags);
    TSSFIELD32(eax);
    TSSFIELD32(ecx);
    TSSFIELD32(edx);
    TSSFIELD32(ebx);
    TSSFIELD32(esp);
    TSSFIELD32(ebp);
    TSSFIELD32(esi);
    TSSFIELD32(edi);
    TSSFIELD16(es);
    // TSSFIELD16(reserved5);
    TSSFIELD16(cs);
    // TSSFIELD16(reserved6);
    TSSFIELD16(ss);
    // TSSFIELD16(reserved7);
    TSSFIELD16(ds);
    // TSSFIELD16(reserved8);
    // TSSFIELD16(fs);
    // TSSFIELD16(reserved9);
    // TSSFIELD16(gs);
    // TSSFIELD16(reserved10);
    // TSSFIELD16(ldtr);
    // TSSFIELD16(reserved11);
    // TSSFIELD16(debug_flag);
    // TSSFIELD16(iomap_base_addr);
    __dbg_printk("--------------------------\n");
}

