
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

typedef unsigned addr_t;


void usage() {
  fprintf(stderr, "Usage: checksum fichier...\n");
  exit(1);
};

int main (int argc, char *argv[]) {
  int i, fd;

  if (argc < 2)
    usage();

  for (i = 1 ; i < argc ; i++) {
    unsigned data, sum, len, rd;
    char *s;
  
    fd = open(argv[i], 0);
    if (fd < 0) {
      perror(argv[i]);
      continue;
    }
    
    data = len = sum = 0;
    while ((rd = read(fd, & data, sizeof(data))) > 0) {
      if (rd != sizeof(data)) {
	memset( (void*) (((addr_t)&data) + rd), 0x0, 4 - rd);
      }
      sum += data;
      len += rd;
    }

    close(fd);

    s = strrchr(argv[i], '/');
    if (! s)
      s = argv[i];
    else if (*s == '/')
      s++;
    printf("Checksum(%s) (0x%x, aka %d octets) = 0x%x\n", s, len, len, sum);
  }
  return 0;
}

